// polycube:  A polyomino and polycube puzzle solver.
// Copyright 2011-2018 Matthew T. Busche.
//
// This program is free software:  you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
// more details.
//
// You should have received a copy of the GNU General Public License along
// with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ESTIMATEHEURISTIC_HPP
#define ESTIMATEHEURISTIC_HPP

#include "OrderingHeuristic.hpp"
#include "Image.hpp"
#include "GridPoint.hpp"

class EstimateHeuristic : public OrderingHeuristic
{
    public:
        EstimateHeuristic();
        DlxHead*           selectDlx() const override;
        ImageListSet       selectFila(int nrp, int nrs, const gridbitfield_t occupancy, bool dlxPristine) const override;
        bool               isFixedOrder() const override;
        std::ostream&      print(std::ostream& os) const override;
        const std::string& getEntityName() const override;

    private:
        const std::string entityName;
};

inline EstimateHeuristic::EstimateHeuristic()
    :
        entityName("g")
{
}

inline bool EstimateHeuristic::isFixedOrder() const
{
    return false;
}

inline const std::string& EstimateHeuristic::getEntityName() const
{
    return entityName;
}

#endif
